package com.itcast.test.tests;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * 计算一个字符串中 英文 字符、数字、空格、等其他字符的个数
 * 思路：
 * 查看jdk api 
 * 1、用java.lang.Character 这个操作字符的类 ，该类提供了几种方法，以确定字符的类别（小写字母，数字，等等），并将字符从大写转换成小写
 * 需要用到的方法：
 * isLetter(char ch) 
          确定指定字符是否为字母。
     isDigit(char ch) 
          确定指定字符是否为数字。
      isSpaceChar(char ch) 
          确定指定字符是否为 Unicode 空白字符。
 * @author Administrator
 *
 */
public class Counter {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {
			String str  = "aa  bbb 123 ddd ***";///可以给个初始值
			//获取键盘输入
			BufferedReader read = new BufferedReader(new InputStreamReader(System.in));
			str = read.readLine();
			checkCharCountInStr_1(str);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	/**
	 * 在一段字符串中 查找 其中相关的 字符、 空格、数字的个数
	 * 这是第一种方法
	 * @param str
	 */
	public static void checkCharCountInStr(String str){
		//判断字符串是否为空
		if(ObjectIsNull(str)){
			throw new RuntimeException("传递进来的字符串为空，请核实！！！");
		}
		//将字符串转换为字符数组
		char [] chs = str.toCharArray();
		int numCount =0 , charCount = 0, spaceCount = 0 ,otherCount = 0;
		for (int i = 0; i < chs.length; i++) {
			///判断是不是 字母
			if(Character.isLetter(chs[i])){
				charCount++;
			}else if(Character.isDigit(chs[i])){///判断是不是数字
				numCount++;
			}else if(Character.isSpaceChar(chs[i])){///判断是不是空格
				spaceCount++;
			}else{
				otherCount ++;
			}
		}
		System.out.println("英文字符数="+charCount +" \n数字个数 = "+ numCount +" \n空格个数 = "+ spaceCount +" \n其他字符个数="+ otherCount);
	}
	/**
	 * 在一段字符串中 查找 其中相关的 字符、 空格、数字的个数
	 * 这是第二种方法
	 * @param str
	 */
	public static void checkCharCountInStr_1(String str){
		//判断字符串是否为空
			if(ObjectIsNull(str)){
				throw new RuntimeException("传递进来的字符串为空，请核实！！！");
			}
			int numCount =0 , charCount = 0, spaceCount = 0 ,otherCount = 0;
			int i =0;
			while(i<str.length()){
				if(Character.isLetter(str.charAt(i))){
					charCount++;
				}else if(Character.isDigit(str.charAt(i))){///判断是不是数字
					numCount++;
				}else if(Character.isSpaceChar(str.charAt(i))){///判断是不是空格
					spaceCount++;
				}else{
					otherCount ++;
				}
				i++;
			}
			System.out.println("英文字符数="+charCount +" \n数字个数 = "+ numCount +" \n空格个数 = "+ spaceCount +" \n其他字符个数="+ otherCount);
	}
	

	/**
	 * 判断一个对象是否为空，简单的判断了下，（其他类型的暂时没写）
	 * @param obj
	 * @return
	 */
	public static boolean ObjectIsNull(Object obj){
		if(obj == null){return true;}
		if("".equals(obj)){return true;}
		return false;
	}
}
